import java.io.IOException;
import java.nio.ByteBuffer;
import java.util.concurrent.Future;
import java.nio.channels.AsynchronousSocketChannel;
import java.util.concurrent.ExecutionException;
import java.net.InetSocketAddress;

public class Client {

    public static void main (String [] args)
            throws Exception {
	
        new Client().go();
    }

    private void go()
            throws IOException, InterruptedException, ExecutionException {
	
        AsynchronousSocketChannel client = AsynchronousSocketChannel.open();
        InetSocketAddress hostAddress = new InetSocketAddress("localhost", 3883);
        Future<Void> future = client.connect(hostAddress);
        future.get(); // returns null

        System.out.println("Client is started");
        System.out.println("Sending message to server: ");
		
        byte [] bytes = new String("Bye").getBytes();
        ByteBuffer buffer = ByteBuffer.wrap(bytes);
        Future<Integer> result = client.write(buffer);
		
        while (! result.isDone()) {
            System.out.println("... ");
        }
		
        System.out.println(new String(buffer.array()).trim());
        buffer.clear();	
		client.close();
	}
}